/*
**	CapturePanel.c
**
**	Editing panel for log file, buffer and capture configuration
**
**	Copyright  1990-1993 by Olaf `Olsen' Barthel & MXM
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_LOGACTIONS, GAD_LOGFILE, GAD_SELECT_LOGFILE, GAD_LOGCALLS, GAD_CALL_LOGFILE,GAD_SELECT_CALL_LOGFILE,
		GAD_MAX_BUFFER_SIZE,GAD_BUFFER_ENABLED,GAD_BUFFER_PATH,GAD_SELECT_BUFFER_PATH,
		GAD_CONNECT_AUTO_CAPTURE, GAD_CAPTURE_FILTER,
		GAD_CAPTURE_PATH, GAD_SELECT_CAPTURE_PATH, GAD_USE, GAD_CANCEL, GAD_DEFAULT };

STATIC struct Gadget *
CreateAllGadgets(struct Configuration *Config,struct Gadget **GadgetArray,struct Gadget **GadgetList,BYTE *Default)
{
	struct Gadget		*Gadget;
	struct NewGadget	 NewGadget;
	UWORD			 Counter = 0;

	SZ_SizeSetup(Window -> WScreen,&UserFont,TRUE);

	memset(&NewGadget,0,sizeof(struct NewGadget));

	if(Gadget = CreateContext(GadgetList))
	{
		SZ_AddLeftOffset(SZ_LeftOffsetDelta(MSG_CAPTUREPANEL_LOG_ACTIONS_GAD,MSG_CAPTUREPANEL_CAPTURE_PATH_GAD));

		SZ_ResetMaxWidth();

		SZ_UpdateMaxWidth(FILE_KIND,NULL,20,NULL);
		SZ_UpdateMaxWidth(INTEGER_KIND,NULL,20,NULL);
		SZ_UpdateMaxWidth(FOLDER_KIND,NULL,20,NULL);

		SZ_SetWidth(SZ_ResetMaxWidth());

		NewGadget . ng_GadgetText	= LocaleString(MSG_CAPTUREPANEL_LOG_ACTIONS_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTCB_Checked,	Config -> CaptureConfig -> LogActions,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_CAPTUREPANEL_LOGFILE_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_LeaveFolder,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> CaptureConfig -> LogFileName,
		TAG_DONE);

		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(FILE_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_PlaceLeft,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_CAPTUREPANEL_LOG_CALLS_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignExtra,	TRUE,

			GTCB_Checked,	Config -> CaptureConfig -> LogCall,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_CAPTUREPANEL_CALL_LOGFILE_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_LeaveFolder,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> CaptureConfig -> CallLogFileName,
		TAG_DONE);

		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(FILE_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_PlaceLeft,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_CAPTUREPANEL_MAX_BUFFER_SIZE_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(INTEGER_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignExtra,	TRUE,

			GTIN_MaxChars,	8,
			GTIN_Number,	Config -> CaptureConfig -> MaxBufferSize,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_CAPTUREPANEL_BUFFER_ENABLED_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTCB_Checked,	Config -> CaptureConfig -> BufferEnabled,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_CAPTUREPANEL_BUFFER_PATH_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_LeaveFolder,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> CaptureConfig -> BufferPath,
		TAG_DONE);

		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(FOLDER_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_PlaceLeft,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_CAPTUREPANEL_CONNECT_AUTO_CAPTURE_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignExtra,	TRUE,

			GTCB_Checked,	Config -> CaptureConfig -> ConnectAutoCapture,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_CAPTUREPANEL_CAPTURE_FILTER_ENABLED_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTCB_Checked,	Config -> CaptureConfig -> CaptureFilterMode,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_CAPTUREPANEL_CAPTURE_PATH_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_LeaveFolder,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> CaptureConfig -> CapturePath,
		TAG_DONE);

		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(FOLDER_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_PlaceLeft,	TRUE,
		TAG_DONE);

		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_USE_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_CANCEL_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_DEFAULT_GAD),0,NULL);

		SZ_SetWidth(SZ_ResetMaxWidth());

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_USE_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= 0;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_AlignExtra,	TRUE,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignLeft,	TRUE,
			SZ_AlignBottom,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_CANCEL_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignRight,	TRUE,
		TAG_DONE);

		if(Default)
		{
			NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_DEFAULT_GAD);
			NewGadget . ng_GadgetID		= Counter;

			GadgetArray[Counter] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
				SZ_Adjust,	TRUE,
				SZ_AutoWidth,	TRUE,
				SZ_AlignCentre,	TRUE,
			TAG_DONE);
		}
	}

	return(Gadget);
}

BYTE
CapturePanel(struct Configuration *Config,BYTE *Default)
{
	struct Window	*PanelWindow;
	struct Gadget	*GadgetList = NULL;
	struct Gadget	*GadgetArray[GAD_DEFAULT + 1];

	SaveConfig(Config,PrivateConfig);

	if(CreateAllGadgets(Config,GadgetArray,&GadgetList,Default))
	{
		if(PanelWindow = OpenWindowTags(NULL,
			WA_Left,	GetScreenLeft(Window) + (GetScreenWidth(Window) - SZ_GetWindowWidth()) / 2,
			WA_Top,		GetScreenTop(Window) + (GetScreenHeight(Window) - SZ_GetWindowHeight())	/ 2,
			WA_Width,	SZ_GetWindowWidth(),
			WA_Height,	SZ_GetWindowHeight(),

			WA_Activate,	TRUE,
			WA_DragBar,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_RMBTrap,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_CloseGadget,	TRUE,
			WA_CustomScreen,Window -> WScreen,

			WA_IDCMP,	IDCMP_GADGETDOWN | IDCMP_ACTIVEWINDOW | IDCMP_CLOSEWINDOW | IDCMP_VANILLAKEY | IDCMP_RAWKEY | BUTTONIDCMP | CHECKBOXIDCMP | INTEGERIDCMP | STRINGIDCMP,

			WA_Title,	LocaleString(MSG_CAPTUREPANEL_CAPTURE_SETTINGS_TXT),
		TAG_DONE))
		{
			struct IntuiMessage	*Massage;
			ULONG			 IClass,Code;
			struct Gadget		*Gadget;
			BYTE			 Terminated = FALSE;

			UBYTE			 DummyBuffer[MAX_FILENAME_LENGTH],
						*DummyChar;
			struct FileRequester	*FileRequest;

			GuideContext(CONTEXT_CAPTURE);

			PushWindow(PanelWindow);

			AddGList(PanelWindow,GadgetList,(UWORD)-1,(UWORD)-1,NULL);
			RefreshGList(GadgetList,PanelWindow,NULL,(UWORD)-1);
			GT_RefreshWindow(PanelWindow,NULL);

			ActiveGadget = NULL;

			SetSignal(0,SIG_BREAK);

			while(!Terminated)
			{
				if(Wait(PORTMASK(PanelWindow -> UserPort) | SIG_BREAK) & SIG_BREAK)
				{
					SaveConfig(PrivateConfig,Config);

					break;
				}

				while(!Terminated && (Massage = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort)))
				{
					IClass	= Massage -> Class;
					Code	= Massage -> Code;
					Gadget	= (struct Gadget *)Massage -> IAddress;

					GT_ReplyIMsg(Massage);

					KeySelect(GadgetArray,GAD_CANCEL,Code,PanelWindow,&Gadget,&IClass,&Code);

					if(IClass == IDCMP_GADGETDOWN)
					{
						if((Gadget -> GadgetType & GTYP_GTYPEMASK) == GTYP_STRGADGET)
							ActiveGadget = Gadget;
					}

					if(IClass == IDCMP_ACTIVEWINDOW && ActiveGadget)
						ActivateGadget(ActiveGadget,PanelWindow,NULL);

					if(IClass == IDCMP_CLOSEWINDOW)
					{
						SaveConfig(PrivateConfig,Config);

						Terminated = TRUE;
					}

					if(IClass == IDCMP_GADGETUP)
					{
						switch(Gadget -> GadgetID)
						{
							case GAD_SELECT_LOGFILE:

								BlockWindow(PanelWindow);

								strcpy(DummyBuffer,SZ_GetString(GadgetArray[GAD_LOGFILE]));

								if(DummyBuffer[0])
								{
									if(FilePart(DummyBuffer) == DummyBuffer)
										DummyBuffer[0] = 0;
									else
									{
										DummyChar = PathPart(DummyBuffer);

										*DummyChar = 0;
									}

									DummyChar = FilePart(SZ_GetString(GadgetArray[GAD_LOGFILE]));
								}
								else
									DummyChar = "";

								if(FileRequest = GetFile(LocaleString(MSG_CAPTUREPANEL_SELECT_LOGFILE_TXT),DummyBuffer,DummyChar,DummyBuffer,NULL,FALSE,FALSE,FALSE,LocaleString(MSG_GLOBAL_SELECT_TXT)))
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_LOGFILE],PanelWindow,NULL,
										GTST_String,DummyBuffer,
									TAG_DONE);

									FreeAslRequest(FileRequest);
								}

								ReleaseWindow(PanelWindow);
								break;

							case GAD_SELECT_CALL_LOGFILE:

								BlockWindow(PanelWindow);

								strcpy(DummyBuffer,SZ_GetString(GadgetArray[GAD_CALL_LOGFILE]));

								if(DummyBuffer[0])
								{
									if(FilePart(DummyBuffer) == DummyBuffer)
										DummyBuffer[0] = 0;
									else
									{
										DummyChar = PathPart(DummyBuffer);

										*DummyChar = 0;
									}

									DummyChar = FilePart(SZ_GetString(GadgetArray[GAD_CALL_LOGFILE]));
								}
								else
									DummyChar = "";

								if(FileRequest = GetFile(LocaleString(MSG_CAPTUREPANEL_SELECT_CALL_LOGFILE_TXT),DummyBuffer,DummyChar,DummyBuffer,NULL,FALSE,FALSE,FALSE,LocaleString(MSG_GLOBAL_SELECT_TXT)))
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_CALL_LOGFILE],PanelWindow,NULL,
										GTST_String,DummyBuffer,
									TAG_DONE);

									FreeAslRequest(FileRequest);
								}

								ReleaseWindow(PanelWindow);
								break;

							case GAD_SELECT_CAPTURE_PATH:

								BlockWindow(PanelWindow);

								strcpy(DummyBuffer,SZ_GetString(GadgetArray[GAD_CAPTURE_PATH]));

								if(FileRequest = GetFile(LocaleString(MSG_CAPTUREPANEL_SELECT_CAPTURE_PATH_TXT),DummyBuffer,"",DummyBuffer,NULL,FALSE,FALSE,TRUE,LocaleString(MSG_GLOBAL_SELECT_TXT)))
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_CAPTURE_PATH],PanelWindow,NULL,
										GTST_String,FileRequest -> rf_Dir,
									TAG_DONE);

									FreeAslRequest(FileRequest);
								}

								ReleaseWindow(PanelWindow);

								break;

							case GAD_SELECT_BUFFER_PATH:

								BlockWindow(PanelWindow);

								strcpy(DummyBuffer,SZ_GetString(GadgetArray[GAD_BUFFER_PATH]));

								if(FileRequest = GetFile(LocaleString(MSG_CAPTUREPANEL_SELECT_BUFFER_PATH_TXT),DummyBuffer,"",DummyBuffer,NULL,FALSE,FALSE,TRUE,LocaleString(MSG_GLOBAL_SELECT_TXT)))
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_BUFFER_PATH],PanelWindow,NULL,
										GTST_String,FileRequest -> rf_Dir,
									TAG_DONE);

									FreeAslRequest(FileRequest);
								}

								ReleaseWindow(PanelWindow);

								break;

							case GAD_USE:

								Terminated = TRUE;

								Config -> CaptureConfig -> LogActions		= SZ_GetChecked(GadgetArray[GAD_LOGACTIONS]);
								Config -> CaptureConfig -> LogCall		= SZ_GetChecked(GadgetArray[GAD_LOGCALLS]);
								Config -> CaptureConfig -> MaxBufferSize	= SZ_GetInteger(GadgetArray[GAD_MAX_BUFFER_SIZE]);
								Config -> CaptureConfig -> BufferEnabled	= SZ_GetChecked(GadgetArray[GAD_BUFFER_ENABLED]);
								Config -> CaptureConfig -> ConnectAutoCapture	= SZ_GetChecked(GadgetArray[GAD_CONNECT_AUTO_CAPTURE]);
								Config -> CaptureConfig -> CaptureFilterMode	= SZ_GetChecked(GadgetArray[GAD_CAPTURE_FILTER]);

								strcpy(Config -> CaptureConfig -> LogFileName,	SZ_GetString(GadgetArray[GAD_LOGFILE]));
								strcpy(Config -> CaptureConfig -> CapturePath,	SZ_GetString(GadgetArray[GAD_CAPTURE_PATH]));

								strcpy(Config -> CaptureConfig -> CallLogFileName,	SZ_GetString(GadgetArray[GAD_CALL_LOGFILE]));
								strcpy(Config -> CaptureConfig -> BufferPath,	SZ_GetString(GadgetArray[GAD_BUFFER_PATH]));

								break;

							case GAD_CANCEL:

								Terminated = TRUE;

								SaveConfig(PrivateConfig,Config);

								break;

							case GAD_DEFAULT:

								*Default	= TRUE;

								Terminated	= TRUE;

								break;
						}
					}
				}
			}

			RemoveGList(PanelWindow,GadgetList,(UWORD)-1);

			PopWindow();

			CloseWindow(PanelWindow);
		}
	}

	FreeGadgets(GadgetList);

	return((BYTE)memcmp(PrivateConfig -> CaptureConfig,Config -> CaptureConfig,sizeof(struct CaptureSettings)));
}
